;#################################################################
;#
;#   STE-FIX , ATARI Corporation
;#
;# Disassembliert und mit XBRA _INF versehen, auerdem wurde die
;# Versionsnummer auf 1.1 erhht.
;#
;#     Von Karsten Isakovic
;#
;# Das Orginal scheint in TurboC geschrieben zu sein, die Namen
;# aus der Symbol Tabelle habe ich bernommen. Es war keine DOKU
;# zu dem PRG vorhanden, der einzige Zweck, den es verfolgt, ist
;# abzuwarten, bis vom Desktop das Desktop.Inf File eingelesen wird
;# und dann das erste #E in ein #F umzuwandeln. 
;#

start:	bra	startup 
	dc.b	'XBRA_INF'
OldGemdos:
	dc.l	0	
mytrap1:
	btst.b	#$D,(a7)
	bne	suptrp
	bra	ghead		; Im NormalModus aufgerufen -> gleich weiter
suptrp:	tst.w	$59E		; undokumentiert...
	bne	lstk
	lea	6(a7),a0
	bra	chkfn 
lstk:	lea	8(a7),a0	; Parameter 8(SSP)
chkfn:	cmpi.w	#$3D,(a0)	; Fopen 
	bne	ckread
	movea.l	2(a0),a0	; ReturnAdresse < $E00000
	cmpa.l	#$E00000,a0 
	blt	ghead 		; ja -> weiter
	lea	deskinf(pc),a1
	moveq	#$B,d0
tstb:	cmpm.b	(a0)+,(a1)+	; Namen auf 'DESKTOP.INF' testen
	bne	ghead		; nein -> weiter
	dbf	d0,tstb 
	st	gotopen		; ja   -> Flag setzen, weiter 
	bra	ghead
;
ckread:	cmpi.w	#$3F,(a0)	; Fread ?
	bne	noread
	tst.b	gotopen		; Desktop.Inf Flag ?
	beq	ghead 
	move.l	8(a0),readbuf	; PufferAdresse sichern
	move.l	2(a7),saveret	; Dahinterhngen
	move.l	#$10076,2(a7) 
noread:	clr.w	gotopen		; Flag wieder lschen
ghead:	move.l	OldGemdos(pc),a0
	jmp	(a0)
;
mungeit:move.l	d0,d1		; Negativer ReturnWert ?
	blt	xmung		; weiter...
	movea.l	readbuf,a0	; Sonst Anzahl der gelesenen Zeichen. 
getbyt:	cmpi.b	#'#',(a0)+
	bne	nxbyt 
	cmpi.b	#'E',(a0) 
	beq	gote
nxbyt:	dbf	d1,getbyt	; D1 ist Anzahl der gelesenen Zeichen 
	bra	xmung 
gote:	addq.b	#1,6(a0)	; das erste '#E' wird zu '#F'
xmung:	movea.l	saveret,a0
	jmp	(a0)
	illegal 

gotopen:	dc.w	0 
readbuf:	dc.l	0 
saveret:	dc.l	0 
deskinf:	dc.b	'DESKTOP.INF',0 
cookie_j:	ds.l	80	; Platz fr 40 Cookies

startup:movea.l	4(a7),a3	; Typisch C- Compiler
	movea.l	$C(a3),a0 
	adda.l	$14(a3),a0
	adda.l	$1C(a3),a0
	adda.w	#$100,a0	; Reale Lnge aus Basepage
	move.l	a3,d0 
	add.l	a0,d0 
	and.b	#$FC,d0		; Stack einrichten
	movea.l	d0,a7 
	move.l	a0,-(a7)
	move.l	a3,-(a7)
	move.w	#0,-(a7)          
	move.w	#$4A,-(a7)	; Mshrink auf reale Gre
	trap	#1
	lea	$C(a7),a7 
	bsr	main
	clr.w	-(a7) 
	move.l	#startup-start,-(a7) 
	move.w	#$31,-(a7)	;Ptermres
	trap	#1 
	illegal 

validate:	
	move.l  a2,-(a7)
	move.l  a3,-(a7)
	clr.w   d0
	moveq   #0,d1 
	lea     errno,a1
	move.w  d0,(a1) 
	movea.l $5A0,a0		; CookieJar Pointer
	move.l  a0,d2 
	bne     V_Tst_2
	bra     Not_STE

Tst_2_loop:
	cmpi.l  #"_INF",(a0) 	; nach _INF suchen
	bne     V_GoOn
	move.w  #-1,(a1) 	; 'Already installed' Error
	bra	val_end

V_GoOn:	cmpi.l  #"_MCH",(a0) 	; nach _MCH (Machine) Cookie suchen
	bne     V_Nxt
	cmpi.l  #$10000,4(a0) 
	bne     Not_STE
	moveq   #1,d0 
V_Nxt:	addq.l  #1,d1 
	addq.w  #8,a0 		; Nchster Cookie
V_Tst_2:move.l  (a0),d2 
	bne     Tst_2_loop
	tst.w   d0		; STE-Cookie gefunden ?
	bne     V_Tst_3

Not_STE:move.w  #-2,(a1)	; 'Not STE' Error
	bra     val_end

V_Tst_3:movea.l $4F2,a2 		; _sysheader
	cmpi.l  #$07291989,$18(a2)	; 29.07.1989	Datum testen
	beq     V_Tst_4
	move.w  #-3,(a1) 
	bra     val_end

V_Tst_4:cmp.l   4(a0),d1		; Noch Platz fr weiteren
	ble     V_Tst_5			;   Cookie ??
	move.l  #"_INF",(a0) 		; Neuen Cookie installieen
	move.l  #$10001,4(a0) 		; VersionsNummerauf 1.1
	addq.w  #8,a0
	clr.l   (a0)
	moveq   #1,d0
	add.l   d1,d0 
	move.l  d0,4(a0)
	bra     val_end

V_Tst_5:movea.l $5A0,a0 		; CookieJar Bereich kopieren
	lea     cookie_j,a1 
	move.l  a1,$5A0 
	bra     V_Copy

Tst_5_loop:
	movea.l a0,a2
	addq.w  #8,a0 
	movea.l a1,a3 
	addq.w  #8,a1 
	move.l  (a2)+,(a3)+ 		; Kennung
	move.l  (a2)+,(a3)+ 		; Inhalt kopieren
V_Copy: move.l  (a0),d0
	bne	Tst_5_loop
	move.l	#"_INF",(a1) 		; Cookie installieren
	move.l	#$10001,4(a1) 		; Versionsnummer auf 1.1
	addq.w	#8,a1
	clr.l	(a1)
	move.l	#$28,4(a1)
val_end:movea.l	(a7)+,a3
	movea.l	(a7)+,a2
	rts 
	
main:   lea	validate(pc),a0	; TOS und 'already installed' testen
	jsr     Supexec(pc) 
	lea     CrLf,a0 
	jsr     Cconws(pc)
	move.w  errno,d0
	beq     NoError
	lea     Error,a0 
	jsr     Cconws(pc)
NoError:move.w  errno,d0	; Die zu 'errno' gehrige Meldung ausgeben
	neg.w   d0
	lsl.w   #2,d0 
	lea     msg,a0
	movea.l 0(a0,d0),a0 
	jsr     Cconws(pc)
	lea     EndMsg,a0 
	jsr     Cconws(pc)
	move.w  errno,d0
	beq     Install
	jsr     Pterm0(pc)	; kommt nicht zurck...
Install:lea     mytrap1(pc),a0
	moveq   #$21,d0		; Gemdos Trap umhngen
	jsr     Setexc(pc)
	move.l  a0,OldGemdos	; alten Rcksprung eintragen
	rts 
;
; Die Bibliothek deutet auf TurboC hin, da die Parameter
; in Registern bergeben werden.
;
Pterm0: move.w  #0,-(a7) 
	trap    #1 
;
Cconws: move.l  a0,-(a7)
	move.w  #9,-(a7)
	trap    #1
	addq.w  #6,a7 
	rts 
;
Setexc:	move.l  a2,-(a7)
	move.l  a0,-(a7)
	move.w  d0,-(a7)
	move.w  #5,-(a7)
	trap    #$D 
	addq.w  #8,a7 
	movea.l d0,a0 
	movea.l (a7)+,a2
	rts 
;
Supexec:move.l  a2,-(a7)
	move.l  a0,-(a7)
	move.w  #$26,-(a7) 	
	trap    #$E 
	addq.w  #6,a7 
	movea.l (a7)+,a2
	rts 
;
msg:	dc.l	msg_a,err_1,err_2,err_3
msg_a:	dc.b	'DESKTOP.INF 1.1 patch installed',0
err_1:	dc.b	'already installed',0 
err_2:	dc.b	'this machine is not an STE',0
err_3:	dc.b	'this STE ROM version does not need the patch',0 

CrLf:	dc.b	$D,$A,0 
Error:
L10423:	dc.b	'ERROR: ',0 
EndMsg:	dc.b	'.',$D,$A,0,0

	.bss 

errno:	ds.b	$1002

